﻿using Bizgaze.CRM.Visitors.Infos;
using Org.BouncyCastle.Asn1.Ocsp;
using System;
using System.Collections.Generic;
using System.Text.Json;
using System.Threading.Tasks;
using Unibase.Data.Expressions;
using Unibase.Data.Sorting;
using Unibase.Data.Sql;
using Unibase.Platform.Analytics.Requests;
using Unibase.Platform.Apps.Managers;
using Unibase.Platform.Data;
using Unibase.Platform.Forms.Providers;
using Unibase.Platform.Keys;

namespace CRM.Visitors.ActionProviders
{
    public class UpdateCheckoutPreAction : BaseFormActionProvider, IFormActionProvider
    {
        public string ControllerClass
        {
            get
            {
                return "Bizgaze.CRM.Visitors.ActionProviders.UpdateCheckoutPreAction";

            }
        }
        public string FormActionName
        {
            get
            {
                return "UpdateCheckoutPreAction";
            }
        }
        public string Description
        {
            get
            {
                return "Update Checkout PreAction";
            }
        }
        public UniqueKey UniqueId
        {
            get
            {
                return Bizgaze.CRM.Actions.UpdateCheckoutPreAction;
            }
        }
        public int ActionType
        {
            get
            {
                return (int)Unibase.Platform.Forms.Enums.FormActionProvider.PreAction;
            }
        }

        public async Task<ActionResponse<FormActionResponse>> ExecuteAsync(ActionRequest srequest, FormActionProviderObject providerObject)
        {

            using (var requestTrans = await srequest.BeginTransactionAsync())
            {
                var IdValue = providerObject.IdValue;
                var arequest = SelectRequest.FromRequest(srequest);
                var obj = providerObject.RequestObject;
                var returnresponse = new FormActionResponse();
                var defaultPKValue = providerObject.DefaultPKValue;
                var stageManager = Unibase.Dependency.DependencyConfig.Resolve<IStageManager>();
                dynamic visitorparam = new Dictionary<string, object>();
                var dictObj = obj as IDictionary<string, dynamic>;
                var connection = GetConnection(srequest);
                var req = dictObj as IDictionary<string, object>;
                var code = Convert.ChangeType(dictObj["uniqueid"].ToString(), typeof(string));
                arequest.SortBy(new SortList()
                    {
                         new Sort("createddate",Unibase.Data.Enums.SortOrder.Desc)

                    });
                var select = "select * from bizgazecrm_visitors where code='" + code + "'  order by visitorid desc";
                //var select = new Unibase.Data.Sql.Select("bizgazecrm_visitors").AllColumns().Where("code", code);
                var parameters = new List<Unibase.Data.Parameter>();
                parameters.Add(new Unibase.Data.Parameter("@code", code));
                var dt = await GetDataTableAsync(arequest, select, parameters);
                if (dt.Rows.Count > 0)
                {
                    var visitorManager = Unibase.Dependency.DependencyConfig.Resolve<Bizgaze.CRM.Visitors.Managers.IVisitorManager>();
                    var visitorid = dt.Rows[0]["visitorid"];
                    var tenantId = dt.Rows[0]["tenantid"];
                    var typeofvisitor = dt.Rows[0]["typeofvisitor"];
                    if (typeofvisitor == 2)
                    {
                        return ActionResponse<FormActionResponse>.CreateErrorResponse("1", "Please Check-In First");
                    }
                    var feedBackJson = Convert.ChangeType(req["feedbackrating"].ToString(), typeof(object)).ToString();
                    var feedBackObj = JsonSerializer.Deserialize<CRM.Visitors.Request.VisitorRequest>(feedBackJson);
                    var comments = feedBackObj.Comments;
                    var rating = feedBackObj.Rating;
                    var select2 = new Unibase.Data.Sql.Select("bizgazecrm_visitorcheckout").AllColumns().Where("visitorid", visitorid);
                    var parameters2 = new List<Unibase.Data.Parameter>();
                    parameters2.Add(new Unibase.Data.Parameter("@visitorid", visitorid));
                    var dt2 = await GetDataTableAsync(arequest, select2, parameters2);
                    var checkoutid = Convert.ToInt64(dt2.Rows[0]["visitorcheckoutid"]);
                    var versionguid = dt2.Rows[0]["versionguid"].ToString();
                    EntityOptions options1 = new EntityOptions();
                    options1.IsNewEntity = false;
                    options1.IsIdentity = true;
                    options1.PkColumn = "visitorcheckoutid";
                    options1.Id = checkoutid;
                    options1.TableName = "bizgazecrm_visitorcheckout";
                    var Updatecheckoutdate = new Update("bizgazecrm_visitorcheckout").Value("checkoutdate", DateTime.Now).Where(Exp.Eq("visitorId", visitorid));
                    await _repository.ExecuteAsync(srequest, Updatecheckoutdate);
                    var updateValues = new Dictionary<string, object>();
                    updateValues.Add("createddate", DateTime.Now);
                    updateValues.Add("uniqueid", code);
                    updateValues.Add("comments", comments.ToString());
                    updateValues.Add("rating", Convert.ToInt32(rating));
                    updateValues.Add("versionguid", versionguid);
                    var dm = await _repository.SaveAsync(srequest, options1, updateValues);
                    var visitorInfo = await visitorManager.GetpreVisitorsAsync(arequest, code);
                    var stageStatusName = "CheckOut";
                    var installedAppId = Convert.ToInt64(visitorInfo.Result.Installedappid);
                    var stage = await stageManager.GetStageByStageStatusAsync(arequest, installedAppId, stageStatusName);
                    var NewStageId = stage.Result.StageId;
                    var UpdateStage = new Update("bizgazecrm_visitors").Value("stageid", NewStageId).Value("lastupdateddate", DateTime.Now).Where(Exp.Eq("code", code));
                    await _repository.ExecuteAsync(srequest, UpdateStage);

                }
                returnresponse = new FormActionResponse();
                returnresponse.Obj = null;
                returnresponse.PkValue = 0;
                return ActionResponse<FormActionResponse>.CreateSuccessResponse("success", returnresponse);
            }
        }
        public List<UniqueKey> AppliedApps
        {
            get
            {
                return new List<UniqueKey>() {
                    Bizgaze.CRM.Actions.UpdateCheckoutPreAction
            };
            }
        }

    }
}



